#!/bin/sh

WHOAMI=`whoami`
if [ $WHOAMI != "root" ]
then
	echo "Must run as root, use sudo or login as root"
	exit
fi
DATE_EPOCH=`date +%s`

#####################
#remove "console=ttyAMA0,115200" or "console=ttyS0,115200" or FOR NEW VERSION "console=serial0,115200" from /boot/cmdline.txt
#        $ sudo vi /boot/cmdline.txt
if [ `grep -c "console=serial0,115200 " /boot/cmdline.txt` -gt 0 ]
then
	echo "Removing serial console serial0 from /boot/cmdline.txt"
	cp /boot/cmdline.txt /boot/cmdline.txt.original.backup.mopower.$DATE_EPOCH
	cat /boot/cmdline.txt.original.backup.mopower.$DATE_EPOCH | sed 's/console=serial0,115200 //' > /boot/cmdline.txt
else
	echo "Serial console serial0 already disabled in /boot/cmdline.txt"
fi

if [ `grep -c "console=ttyAMA0,115200 " /boot/cmdline.txt` -gt 0 ]
then
        echo "Removing serial console ttyAMA0 from /boot/cmdline.txt"
        cp /boot/cmdline.txt /boot/cmdline.txt.original.backup.mopower.$DATE_EPOCH
        cat /boot/cmdline.txt.original.backup.mopower.$DATE_EPOCH | sed 's/console=ttyAMA0,115200 //' > /boot/cmdline.txt
else
        echo "Serial console ttyAMA0 already disabled in /boot/cmdline.txt"
fi

if [ `grep -c "console=ttyS0,115200 " /boot/cmdline.txt` -gt 0 ]
then
        echo "Removing serial console ttyS0 from /boot/cmdline.txt"
        cp /boot/cmdline.txt /boot/cmdline.txt.original.backup.mopower.$DATE_EPOCH
        cat /boot/cmdline.txt.original.backup.mopower.$DATE_EPOCH | sed 's/console=ttyS0,115200 //' > /boot/cmdline.txt
else
        echo "Serial console ttyS0 already disabled in /boot/cmdline.txt"
fi
#####################

#####################
if [ `grep -c "^enable_uart=1" /boot/config.txt` -lt 1 ]
then
	echo "Turning on UART.. writing enable_uart=1 to /boot/config.txt"
	echo "enable_uart=1" >> /boot/config.txt
else
	echo "UART already enabled.. enable_uart=1 found in /boot/config.txt"
fi
#####################

# LOGROTATE STUFF
cp /etc/cron.daily/logrotate /etc/cron.hourly/
cp /home/pi/mopower/mopower-logrotate /etc/logrotate.d/

# Detail log symbolic link
ln -s /run/shm/mopower/mopower-upslog.detail /var/log/mopower-upslog.detail

#####################
#Stop serial terminal service
sudo systemctl stop serial-getty@ttyAMA0.service	# PREVIOUS
sudo systemctl disable serial-getty@ttyAMA0.service	# PREVIOUS
sudo systemctl stop serial-getty@ttyS0.service		# PI 3
sudo systemctl disable serial-getty@ttyS0.service	# PI 3
sudo systemctl stop serial-getty@serial0.service          # Universal
sudo systemctl disable serial-getty@serial0.service       # Universal
#####################

#Install python-dev python-crcmod python-serial and minicom (optional)
sudo apt-get -y install python-dev python-crcmod python-serial minicom

#Copy UPS poweroff script
sudo cp /home/pi/mopower/mopower-ups-timed-shutdown.sh /lib/systemd/system-shutdown/mopower-ups-timed-shutdown.sh

#edit /etc/rc.local
#        $ sudo vi /etc/rc.local
#and add
#        /home/pi/mopower/mopower-ups-wrapper.sh &
#before the "exit 0" line
if [ `grep -c "^/home/pi/mopower/mopower-ups-wrapper.sh &" /etc/rc.local` -lt 1 ]
then
	echo "Adding Mopower startup script to /etc/rc.local ..."
	cp /etc/rc.local /etc/rc.local.orignal.backup.mopower.$DATE_EPOCH
	cat /etc/rc.local.orignal.backup.mopower.$DATE_EPOCH | sed 's/^exit 0/\/home\/pi\/mopower\/mopower-ups-wrapper.sh \&\n\n&/' > /etc/rc.local
else
	echo "Mopower startup script already in /etc/rc.local"
fi

#edit /home/pi/.profile
#        $ sudo vi /home/pi/.profile
#and add
#        PATH="$HOME/mopower/:$PATH"
#to the end of the file
if [ `grep -c "^PATH=\"\\$HOME/mopower/:\\$PATH\"" /home/pi/.profile` -lt 1 ]
then
        echo "\nPATH=\"\$HOME/mopower/:\$PATH\"" >> /home/pi/.profile

else
        echo "Path already set for mopower directory"
fi

#Reboot your Pi and the UPS client software will automatically run at startup
echo -n "You must reboot for the changes to take effect, reboot now? (y/n) "
read REBOOT

if [ "$REBOOT" = "y" ]
then
	echo "Rebooting..."
	sudo reboot
else
	echo "Remember to reboot soon!"
fi
